/*
 * Copyright (C) 2013 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef CryptoAlgorithmIdentifier_h
#define CryptoAlgorithmIdentifier_h

#if ENABLE(SUBTLE_CRYPTO)

namespace WebCore {

enum class CryptoAlgorithmIdentifier {
    RSAES_PKCS1_v1_5 = 1,
    RSASSA_PKCS1_v1_5,
    RSA_PSS,
    RSA_OAEP,
    ECDSA,
    ECDH,
    AES_CTR,
    AES_CBC,
    AES_CMAC,
    AES_GCM,
    AES_CFB,
    AES_KW,
    HMAC,
    DH,
    SHA_1,
    SHA_224,
    SHA_256,
    SHA_384,
    SHA_512,
    CONCAT,
    HKDF_CTR,
    PBKDF2
};

}

#endif // ENABLE(SUBTLE_CRYPTO)
#endif // CryptoAlgorithmIdentifier_h
